"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _fs = _interopRequireDefault(require("mz/fs"));

var _path = _interopRequireDefault(require("path"));

var _faker = _interopRequireDefault(require("faker"));

var _jsonSchemaFaker = require("json-schema-faker");

var _config = require("./config");

var getSchemas = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(schemaPath, mainSchema) {
    var promises, schema, files, refs;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            promises = [];
            _context.next = 3;
            return _fs["default"].readFile(_path["default"].join(schemaPath, mainSchema));

          case 3:
            schema = _context.sent;
            _context.next = 6;
            return _fs["default"].readdir(schemaPath);

          case 6:
            files = _context.sent;
            files.filter(function (file) {
              return file !== mainSchema && file.endsWith('.json');
            }).forEach(function (file) {
              var promise = _fs["default"].readFile(_path["default"].join(schemaPath, file));

              promises.push(promise);
            });
            _context.next = 10;
            return Promise.all(promises);

          case 10:
            refs = _context.sent;
            return _context.abrupt("return", {
              schema: JSON.parse(schema),
              refs: refs.map(function (ref) {
                return JSON.parse(ref);
              })
            });

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getSchemas(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var generateDb = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
    var _getConfig, schemaPath, mainSchema, dbPath, _yield$getSchemas, schema, refs, db;

    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _getConfig = (0, _config.getConfig)(), schemaPath = _getConfig.schemaPath, mainSchema = _getConfig.mainSchema, dbPath = _getConfig.dbPath;

            if (!(!schemaPath || !mainSchema)) {
              _context2.next = 4;
              break;
            }

            console.log('No schema path supplied');
            return _context2.abrupt("return", null);

          case 4:
            _context2.next = 6;
            return getSchemas(schemaPath, mainSchema);

          case 6:
            _yield$getSchemas = _context2.sent;
            schema = _yield$getSchemas.schema;
            refs = _yield$getSchemas.refs;
            (0, _jsonSchemaFaker.extend)('faker', function () {
              return _faker["default"];
            });
            _context2.next = 12;
            return (0, _jsonSchemaFaker.resolve)(schema, refs, _path["default"].resolve(schemaPath));

          case 12:
            db = _context2.sent;

            if (dbPath) {
              _fs["default"].writeFile(_path["default"].resolve(dbPath, 'db.json'), JSON.stringify(db));
            }

            console.log('Database created successfully');
            return _context2.abrupt("return", db);

          case 16:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function generateDb() {
    return _ref2.apply(this, arguments);
  };
}();

var _default = generateDb;
exports["default"] = _default;