"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _config = require("./config");

var getBase = function getBase(url, port) {
  var base = "http://localhost:".concat(port);
  return new URL(url, base).href;
};

var getMockUrl = function getMockUrl(options) {
  var _getConfig = (0, _config.getConfig)(),
      port = _getConfig.port,
      pageSize = _getConfig.pageSize;

  if (typeof options === 'string') {
    return getBase(options, port);
  }

  var _options$skip = options.skip,
      skip = _options$skip === void 0 ? 0 : _options$skip,
      _options$top = options.top,
      top = _options$top === void 0 ? pageSize : _options$top,
      search = options.search,
      orderby = options.orderby,
      base = options.base;
  var url = getBase(base, port);
  var queryString = "?_page=".concat(skip / pageSize + 1, "&_limit=").concat(top);

  if (search) {
    var keys = search.keys,
        query = search.query;

    if (Array.isArray(keys)) {
      queryString += "&q=".concat(query);
    } else {
      queryString += "&".concat(keys, "_like=").concat(query);
    }
  }

  if (orderby) {
    var _orderby$split = orderby.split(' '),
        _orderby$split2 = (0, _slicedToArray2["default"])(_orderby$split, 2),
        sort = _orderby$split2[0],
        order = _orderby$split2[1];

    queryString += "&_sort=".concat(sort, "&_order=").concat(order);
  }

  return url + queryString;
};

var _default = getMockUrl;
exports["default"] = _default;