"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMockUrl = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var getBase = function getBase(url, port) {
  var base = "http://localhost:".concat(port);
  return new URL(url, base).href;
};

var getMockUrl = function getMockUrl(options) {
  var _options$port;

  var port = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 4000;

  if (typeof options === 'string') {
    return getBase(options, port);
  }

  var _options$pageSize = options.pageSize,
      pageSize = _options$pageSize === void 0 ? 20 : _options$pageSize;
  var _options$skip = options.skip,
      skip = _options$skip === void 0 ? 0 : _options$skip,
      _options$top = options.top,
      top = _options$top === void 0 ? pageSize : _options$top,
      search = options.search,
      orderby = options.orderby,
      base = options.base;
  var url = getBase(base, (_options$port = options.port) !== null && _options$port !== void 0 ? _options$port : port);
  var queryString = "?_page=".concat(skip / pageSize + 1, "&_limit=").concat(top);

  if (search && search.query) {
    var keys = search.keys,
        query = search.query;

    if (Array.isArray(keys)) {
      queryString += "&q=".concat(query);
    } else {
      queryString += "&".concat(keys, "_like=").concat(query);
    }
  }

  if (orderby) {
    var _orderby$split = orderby.split(' '),
        _orderby$split2 = (0, _slicedToArray2["default"])(_orderby$split, 2),
        sort = _orderby$split2[0],
        order = _orderby$split2[1];

    queryString += "&_sort=".concat(sort, "&_order=").concat(order);
  }

  return url + queryString;
}; // eslint-disable-next-line import/prefer-default-export


exports.getMockUrl = getMockUrl;