"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _jsonServer = _interopRequireDefault(require("json-server"));

var _parseLinkHeader = _interopRequireDefault(require("parse-link-header"));

var _config = require("./config");

var serve = function serve(db) {
  if (!db) {
    return;
  }

  var _getConfig = (0, _config.getConfig)(),
      port = _getConfig.port,
      items = _getConfig.items,
      count = _getConfig.count,
      nextPageLink = _getConfig.nextPageLink,
      delay = _getConfig.delay;

  var errorRegex = /\b(4|5)\d\d$/;

  var server = _jsonServer["default"].create();

  var router = _jsonServer["default"].router(db);

  var middlewares = _jsonServer["default"].defaults();

  server.use(function (req, res, next) {
    setTimeout(next, delay);
  });
  server.use(middlewares);
  server.get(errorRegex, function (req, res) {
    var _db$code;

    var code = req.path.substring(1);
    res.status(code).send((_db$code = db[code]) !== null && _db$code !== void 0 ? _db$code : {});
  });

  router.render = function (req, res) {
    var _parse$next$url, _parse, _parse$next, _res$json;

    var _URL = new URL(req.get('Host') + req.originalUrl),
        searchParams = _URL.searchParams;

    var error = searchParams.get('_error');

    if (errorRegex.test(error)) {
      var _db$error;

      return res.status(error).send((_db$error = db[error]) !== null && _db$error !== void 0 ? _db$error : {});
    }

    if (!searchParams.get('_limit')) {
      return res.json(res.locals.data);
    }

    res.json((_res$json = {}, (0, _defineProperty2["default"])(_res$json, items, res.locals.data), (0, _defineProperty2["default"])(_res$json, count, res.get('X-Total-Count')), (0, _defineProperty2["default"])(_res$json, nextPageLink, (_parse$next$url = (_parse = (0, _parseLinkHeader["default"])(res.get('Link'))) === null || _parse === void 0 ? void 0 : (_parse$next = _parse.next) === null || _parse$next === void 0 ? void 0 : _parse$next.url) !== null && _parse$next$url !== void 0 ? _parse$next$url : null), _res$json));
  };

  server.use(router);
  server.listen(port, function () {
    var message = "JSON Server is running at http://localhost:".concat(port);

    if (delay) {
      message += " with a delay of ".concat(delay, "ms");
    }

    console.log(message);
  });
};

var _default = serve;
exports["default"] = _default;